package com.dbxml.db.client.xmldb;

/*
 * dbXML - Native XML Database
 * Copyright (C) 1999-2004  The dbXML Group, L.L.C.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: XUpdateQueryServiceImpl.java,v 1.2 2004/02/12 00:17:56 bradford Exp $
 */

import com.dbxml.db.client.ResultSetClient;
import com.dbxml.db.common.xupdate.XUpdateQueryResolver;
import com.dbxml.util.dbXMLException;

import org.xmldb.api.base.ErrorCodes;
import org.xmldb.api.base.XMLDBException;
import org.xmldb.api.modules.XUpdateQueryService;

/**
 * XUpdateQueryServiceImpl
 */

public final class XUpdateQueryServiceImpl extends QueryServiceImpl implements XUpdateQueryService {
   private static final String NAME = "XUpdateQueryService";
   private static final String STYLE = XUpdateQueryResolver.STYLE_XUPDATE;
   private static final String VERSION = "1.0";

   public XUpdateQueryServiceImpl(CollectionImpl col) {
      super(col, STYLE);
   }

   public String getName() throws XMLDBException {
      return NAME;
   }

   public String getVersion() throws XMLDBException {
      return VERSION;
   }

   private long getModifiedCount(ResultSetClient rs) throws XMLDBException {
      try {
         long count = rs.getCount();
         rs.close();
         return count;
      }
      catch ( dbXMLException e ) {
         throw new XMLDBException(ErrorCodes.VENDOR_ERROR, e.getMessage());
      }
   }

   public long update(String commands) throws XMLDBException {
      return getModifiedCount(performQuery(commands));
   }

   public long updateResource(String id, String commands) throws XMLDBException {
      return getModifiedCount(performQueryResource(id, commands));
   }
}
